<?

class render {

 function render() {
 }

 function init_3D() {
 } 
 
 function finalize() {
 }

 function cc($color) {
 if ($color[0] == "#") $color = substr($color,1);
 $color=hexdec($color);
 $red=($color&0xFF0000)>>16;
 $green = ($color&0xFF00)>>8;
 $blue = ($color&0xFF);
 return array ($red, $green, $blue);
 }
}

class renderISO extends render {

 var $txtcol;
 var $mult = array();
 var $graph_px = 0;
 var $graph_py = 0;
 var $graph_height = 0;
 var $graph_width = 0;

 var $graph;
 var $draw_type = "wireframe";

 function renderISO($graph, $x_offset, $y_offset, $width, $height, $txtcolor, $draw_type) {
 $this->graph = $graph;

 $c = $this->cc($txtcolor);
 $this->txtcol = ImageColorAllocate($this->graph, $c[0], $c[1], $c[2]);

 $this->graph_px = $x_offset;
 $this->graph_py = $y_offset + $height;
 $this->graph_height = $height;
 $this->graph_width = $width;

 $this->draw_type = $draw_type;
 }

 function init_3D($min_x,$max_x,$min_y,$max_y,$min_z,$max_z) {
 
 $this->mult = array(($this->graph_width - 15*($max_z - $min_z))/($max_x - $min_x),($this->graph_height - 15*($max_z - $min_z))/($max_y - $min_y),15,15);
 }

 function get_coords($p) {

 $x = 0;
 $y = 0;

 $x = round($this->graph_px + $p[0] * $this->mult[0] + $p[2] * $this->mult[2]);
 $y = round($this->graph_py - $p[1] * $this->mult[1] - $p[2] * $this->mult[3]);
 
 return array($x, $y);
 }

 function draw_text($txt,$x,$y,$z,$rotation=0,$alignment="topleft",$color="") {
 $p = array($x,$y,$z);

 $pg = $this->get_coords($p);

 if ($color) {
 $c = $this->cc($color);
 $col = ImageColorAllocate($this->graph, $c[0], $c[1], $c[2]);
 } else {
 $col = $this->txtcol;
 }

 

 if ($rotation) {
 ImageStringUp($this->graph, $this->small_font, $pg[0], $pg[1], $txt, $col);
 } else {
 ImageString($this->graph, $this->small_font, $pg[0], $pg[1], $txt, $col);
 }
 }

 function draw_line($x1,$y1,$z1,$x2,$y2,$z2,$color='000000') {

 $c = $this->cc($color);
 $col = ImageColorAllocate($this->graph, $c[0], $c[1], $c[2]);
 $p1 = $this->get_coords(array($x1, $y1, $z1));
 $p2 = $this->get_coords(array($x2, $y2, $z2));

 ImageLine($this->graph, $p1[0], $p1[1], $p2[0], $p2[1], $col);
 }

 function draw_poly($vertices,$color='000000') {
 $from = false;
 reset($vertices);
 while (list($key,$val) = each($vertices)) {
 if ($from) {
 $this->draw_line($from[0],$from[1],$from[2],$val[0],$val[1],$val[2],$color);
 }
 $from = $val;
 }
 }

 function draw_filledpoly($vertices,$color='000000') {
 $c = $this->cc($color);
 $col = ImageColorAllocate($this->graph, $c[0],$c[1],$c[2]);
 reset($vertices);
 $p = array();
 while (list($key,$val) = each($vertices)) {
 $a = get_coords($val);
 $p[] = $a[0];
 $p[] = $a[1];
 }
 ImageFilledPolygon($this->graph, $p, count($vertices), $col);
 }

 function draw_cube($x,$y,$z,$height,$depth,$width,$color='ff0000',$draw_type="") {
 if (!$draw_type) $draw_type = $this->draw_type;
 
 if ($draw_type == "wireframe") {
 $this->draw_line($x, $y, $z, $x + $width, $y, $z, $color);
 $this->draw_line($x, $y, $z, $x, $y, $z + $depth, $color);
 $this->draw_line($x, $y, $z + $depth, $x + $width, $y, $z + $depth, $color);
 $this->draw_line($x + $width, $y, $z, $x + $width, $y, $z + $depth, $color);
 $this->draw_line($x, $y, $z, $x, $y + $height, $z, $color);
 $this->draw_line($x, $y, $z + $depth, $x, $y + $height, $z + $depth, $color);
 $this->draw_line($x + $width, $y, $z, $x + $width, $y + $height, $z, $color);
 $this->draw_line($x + $width, $y, $z + $depth, $x + $width, $y + $height, $z + $depth, $color);
 $this->draw_line($x, $y + $height, $z, $x + $width, $y + $height, $z, $color);
 $this->draw_line($x, $y + $height, $z, $x, $y + $height, $z + $depth, $color);
 $this->draw_line($x, $y + $height, $z + $depth, $x + $width, $y + $height, $z + $depth, $color);
 $this->draw_line($x + $width, $y + $height, $z, $x + $width, $y + $height, $z + $depth, $color); 
 } else if ($draw_type == "hidden") {
 $this->draw_line($x, $y, $z, $x + $width, $y, $z, $color);
 $this->draw_line($x + $width, $y, $z, $x + $width, $y, $z + $depth, $color);
 $this->draw_line($x, $y, $z, $x, $y + $height, $z, $color);
 $this->draw_line($x + $width, $y, $z, $x + $width, $y + $height, $z, $color);
 $this->draw_line($x + $width, $y, $z + $depth, $x + $width, $y + $height, $z + $depth, $color);
 $this->draw_line($x, $y + $height, $z, $x + $width, $y + $height, $z, $color);
 $this->draw_line($x, $y + $height, $z, $x, $y + $height, $z + $depth, $color);
 $this->draw_line($x, $y + $height, $z + $depth, $x + $width, $y + $height, $z + $depth, $color);
 $this->draw_line($x + $width, $y + $height, $z, $x + $width, $y + $height, $z + $depth, $color);
 } else if ($draw_type == "flat" || $draw_type == "shadow" || $draw_type == "shaded") {
 $c = $this->cc($color);
 $col1 = ImageColorAllocate($this->graph,$c[0], $c[1], $c[2]);
 if ($draw_type == "flat") {
 $col2 = ImageColorAllocate($this->graph,$c[0], $c[1], $c[2]);
 $col3 = ImageColorAllocate($this->graph,$c[0], $c[1], $c[2]);
 } else if ($draw_type == "shadow") {
 $col2 = ImageColorAllocate($this->graph,round($c[0]*0.75), round($c[1]*0.75), round($c[2]*0.75));
 $col3 = ImageColorAllocate($this->graph,round($c[0]*0.85), round($c[1]*0.85), round($c[2]*0.85));
 }
 
 $line_col = ImageColorAllocate($this->graph,0,0,0);
 $a = $this->get_coords(array($x, $y, $z));
 $b = $this->get_coords(array($x + $width, $y, $z));
 $c = $this->get_coords(array($x + $width, $y, $z + $depth));
 $e = $this->get_coords(array($x, $y + $height, $z));
 $f = $this->get_coords(array($x + $width, $y + $height, $z));
 $g = $this->get_coords(array($x + $width, $y + $height, $z + $depth));
 $h = $this->get_coords(array($x, $y + $height, $z + $depth));

 if ($draw_type == "flat" || $draw_type == "shadow") {
 ImageFilledPolygon($this->graph,array($a[0],$a[1],$b[0],$b[1],$f[0],$f[1],$e[0],$e[1]),4,$col1);
 ImageFilledPolygon($this->graph,array($b[0],$b[1],$c[0],$c[1],$g[0],$g[1],$f[0],$f[1]),4,$col2);
 ImageFilledPolygon($this->graph,array($e[0],$e[1],$f[0],$f[1],$g[0],$g[1],$h[0],$h[1]),4,$col3);
 if ($draw_type == "flat") {
 ImagePolygon($this->graph,array($a[0],$a[1],$b[0],$b[1],$f[0],$f[1],$e[0],$e[1]),4,$line_col);
 ImagePolygon($this->graph,array($b[0],$b[1],$c[0],$c[1],$g[0],$g[1],$f[0],$f[1]),4,$line_col);
 ImagePolygon($this->graph,array($e[0],$e[1],$f[0],$f[1],$g[0],$g[1],$h[0],$h[1]),4,$line_col);
 }
 } else if ($draw_type == "shaded") {

 }
 }
 }

 function draw_prism() {

 }

 function finalize() {
 }

}

class renderPerspective extends renderISO {

 var $vp=array();
 var $vp_dx;
 var $vp_dy;
 var $vp_d;

 var $min_x;
 var $max_x;
 var $min_y;
 var $max_y;
 var $min_z;
 var $max_z;

 var $offset = array();
 var $rotate = array();
 var $x_scale;
 var $y_scale;
 var $z_scale;

 var $zbuffer=array();
 var $transparent=0;

 function renderPerspective($graph, $x_offset, $y_offset, $width, $height, $txtcolor, $draw_type) {
 $this->renderISO($graph, $x_offset, $y_offset, $width, $height, $txtcolor, $draw_type);
 }

 function init_3D($min_x,$max_x,$min_y,$max_y,$min_z,$max_z) {
 $this->min_x = $min_x;
 $this->max_x = $max_x;
 $this->min_y = $min_y;
 $this->max_y = $max_y;
 $this->min_z = $min_z;
 $this->max_z = $max_z;

 $this->offset = array(-$min_x - ($max_x - $min_x)/2, -$min_y - ($max_y - $min_y)/2, -$min_z - ($max_z - $min_z)/2);
 $this->x_scale = $this->graph_width/($max_x - $min_y);
 $this->y_scale = $this->graph_height/($max_y - $min_y);
 $this->z_scale = 0.2;
 }

 function init_Viewpoint($vp_distance = 1, $rotate_x = 0, $rotate_y = 0, $rotate_z = 0, $transparent = 0) {
 
 $this->transparent = $transparent;
 
 $sx=sin($rotate_x);
 $sy=sin(-$rotate_y);
 $sz=sin($rotate_z);
 $cx=cos($rotate_x);
 $cy=cos(-$rotate_y);
 $cz=cos($rotate_z);
 
 $this->rotate = array($sx*$sy*$sz+$cx*$cz, $cy*$sz, $sx*$cz-$cx*$sy*$sz,
 $sx*$sy*$cz-$cx*$sz, $cy*$cz, -$cx*$sy*$cz-$sx*$sz,
 -$sx*$cy, $sy, $cx*$cy);
 
 $this->vp_d = $vp_distance * ($this->max_x - $this->min_x)/2;
 $this->vp = array(-$this->offset[0],-$this->offset[1],-$this->offset[2]-$this->vp_d);
 }

 function translate($p) {
 $p1=array();
 $p1[0] = $p[0] + $this->offset[0];
 $p1[1] = $p[1] + $this->offset[1];
 $p1[2] = $p[2] + $this->offset[2];
 $p2=array();
 $p2[0] = $p1[0]*$this->rotate[0] + $p1[1]*$this->rotate[1] + $p1[2]*$this->rotate[2];
 $p2[1] = $p1[0]*$this->rotate[3] + $p1[1]*$this->rotate[4] + $p1[2]*$this->rotate[5];
 $p2[2] = $p1[0]*$this->rotate[6] + $p1[1]*$this->rotate[7] + $p1[2]*$this->rotate[8];
 return $p2;
 }

 function get_coords($p) {
 
 $p = $this->translate($p);

 $z = $this->vp_d + $p[2] * $this->z_scale;
 $x = $this->graph_px + $this->graph_width/2 + $this->x_scale * $p[0]/$z;
 $y = $this->graph_py - $this->graph_height/2 - $this->y_scale * $p[1]/$z;

 return array($x,$y);
 }

 function back_culling($p,$n) {
 $vpv = array($p[0] - $this->vp[0], $p[1] - $this->vp[1], $p[2] - $this->vp[2]);
 $norm = abs($vpv[0] + $vpv[1] + $vpv[2]);
 if ($norm > 0) {
 $vpv[0] = $vpv[0]/$norm;
 $vpv[1] = $vpv[1]/$norm;
 $vpv[2] = $vpv[2]/$norm;

 $dotp = $n[0]*$vpv[0] + $n[1]*$vpv[1] + $n[2]*$vpv[2];
 return -$dotp;
 } else {
 return 0;
 }
 }

 function get_pixel($x,$y) {

 }

 function set_pixel($x,$y,$z,$color,$bc=-1) {
 

 if (isset($zbuffer[$px][$py]) && $zbuffer[$px][$py] < $z) return;

 
 }

 function draw_filledpoly($vertices,$color,$bc=-1) {
 $minx=0;
 $miny=0;
 $maxx=0;
 $maxy=0;
 reset($vertices);
 while (list($key,$val)=each($vertices)) {
 
 }
 }

 function draw_text($txt,$x,$y,$z,$rotation=0,$alignment="topleft",$color="") {
 parent::draw_text($txt,$x,$y,$z,$rotation,$alignment,$color);
 }

 function draw_line($x1,$y1,$z1,$x2,$y2,$z2,$color='000000') {
 parent::draw_line($x1,$y1,$z1,$x2,$y2,$z2,$color);
 }

 function draw_cube($x,$y,$z,$height,$depth,$width,$color='ff0000',$draw_type="") {
 if (!$draw_type) $draw_type = $this->draw_type;

 if ($draw_type == "wireframe") { parent::draw_cube($x,$y,$z,$height,$depth,$width,$color,$draw_type); return false; }

 $a = $this->get_coords(array($x, $y, $z));
 $b = $this->get_coords(array($x + $width, $y, $z));
 $c = $this->get_coords(array($x + $width, $y, $z + $depth));
 $d = $this->get_coords(array($x, $y, $z + $depth));
 $e = $this->get_coords(array($x, $y + $height, $z));
 $f = $this->get_coords(array($x + $width, $y + $height, $z));
 $g = $this->get_coords(array($x + $width, $y + $height, $z + $depth));
 $h = $this->get_coords(array($x, $y + $height, $z + $depth));
 
 $bc = array();
 $pg = array();

 $bc[0] = $this->back_culling(array($x + $width/2, $y + $height/2, $z), array(0,0,-1));
 $pg[0] = array(array($x, $y, $z),array($x + $width, $y, $z),array($x + $width, $y + $height, $z),array($x, $y + $height, $z));
 $bc[1] = $this->back_culling(array($x + $width, $y + $height/2, $z + $depth/2), array(1,0,0));
 $pg[1] = array(array($x + $width, $y, $z),array($x + $width, $y, $z + $depth),array($x + $width, $y + $height, $z + $depth),array($x + $width, $y + $height, $z));
 $bc[2] = $this->back_culling(array($x + $width/2, $y + $height/2, $z + $depth), array(0,0,1));
 $pg[2] = array(array($x + $width, $y, $z + $depth),array($x, $y, $z + $depth),array($x, $y + $height, $z + $depth),array($x + $width, $y + $height, $z + $depth));
 $bc[3] = $this->back_culling(array($x, $y + $height/2, $z + $depth/2), array(-1,0,0));
 $pg[3] = array(array($x, $y, $z + $depth),array($x, $y, $z),array($x, $y + $height, $z),array($x, $y + $height, $z + $depth));
 $bc[4] = $this->back_culling(array($x + $width/2, $y + $height, $z + $depth/2), array(0,1,0));
 $pg[4] = array(array($x, $y + $height, $z),array($x + $width, $y + $height, $z),array($x + $width, $y + $height, $z + $depth),array($x, $y + $height, $z + $depth));
 $bc[5] = $this->back_culling(array($x + $width/2, $y, $z + $depth/2), array(0,-1,0));
 $pg[5] = array(array($x, $y, $z + $depth),array($x + $width, $y, $z + $depth),array($x + $width, $y, $z),array($x, $y, $z));

 $c = $this->cc($color);
 $col = ImageColorAllocate($this->graph,$c[0],$c[1],$c[2]);
 if ($draw_type == "hidden") {
 for ($i = 0; $i < 6; $i++) {
 if ($bc[$i] > 0) {
 draw_poly($pg[$i],$color);
 }
 }
 }
 if ($draw_type == "flat" || $draw_type == "shaded") {
 for ($i = 0; $i < 6; $i++) {
 if ($bc[$i] > 0) {
 if ($draw_type == "flat") $this->draw_poly($pg[$i],'000000');
 $this->draw_filledpoly($pg[$i],$color,$bc[$i]);
 }
 }
 } 
 
 }

 function draw_prism() {

 }

}

?>
