<?







































function find_closing_tag_end( $subject, $closingTag, $start, $openingTags, $closingTags, $depth=0 )
{
 
 $pos = strpos( $subject, $closingTag, $start );
 if ( $pos === false )
 return false;
 
 $tagCounter = Array();
 $firstOpener = "";
 $firstOpenerPos = -1;
 foreach ( $openingTags as $key=>$oTag )
 {
 $openPos = strpos( $subject, $oTag, $start );
 if ( $openPos !== false )
 {
 if ( $openPos < $pos && ($openPos < $firstOpenerPos || $firstOpenerPos < 0 ) )
 {
 $firstOpenerPos = $openPos;
 $firstOpener = $key; 
 }
 }
 }
 if ( $firstOpenerPos >= 0 )
 {
 $newOffset = find_closing_tag_end( $subject, $closingTags[$firstOpener],
 $firstOpenerPos+strlen($openingTags[$firstOpener]), $openingTags, $closingTags, $depth+1 );
 if ( $newOffset === false )
 return false;
 return find_closing_tag_end( $subject, $closingTag, $newOffset, $openingTags, $closingTags, $depth+1 );
 }
 else
 {
 return $pos + strlen($closingTag);
 }
}








function div2tag( $divstr, $tagName )
{
 global $TAG_PREFIX, $FEATURE;

 $tmp = strtolower( $divstr );
 $end = 0;
 $ret = "";
 $start = strpos( $tmp, "<$tagName" );
 while ( $start !== false )
 {
 $ret .= substr( $divstr, $end, $start-$end );
 
 $end = find_closing_tag_end( $tmp, "</$tagName>", $start + (strlen($tagName) + 1), array("<$tagName"), array("</$tagName>") );
 $tag = substr( $divstr, $start, $end-$start );
 $matches = array();
 if (preg_match_all( "/id=\"?t_([^ >\"]*)/i", $tag, $matches )) {
 $ret .= "<$TAG_PREFIX ".$matches[1][0].">";
 } else {
 $ret .= $tag;
 }
 $start = strpos( $tmp, "<$tagName", $end );
 }
 $ret .= substr( $divstr, $end );
 
 return $ret;
}





function isLiveEditTidy() {
 global $FEATURE, $NODE_ID;

 
 if (!$FEATURE["liveedit_tidy"]) {
 return false;
 }

 $tidyfor = explode(",",$FEATURE["liveedit_tidy"]);
 foreach ( $tidyfor as $t ) {
 if (trim($t) == "*" || trim($t) == $NODE_ID) {
 return true;
 }
 }

 return false;
}
















function logPossibleDataLoss($tagname, $pageid, $partid, $value_posted, $value_parsed, $value_ieparsed, $value_pretidy, $value_tidy, $value_posttidy, $value_tosave) {
 global $USER_ID, $TIME, $FEATURE, $LIVEEDITORSAVELOG_PERC;
 if (!$FEATURE["liveeditorsavelog"]) {
 return;
 }
 
 $loss_threshold = 10;
 if (is_numeric($LIVEEDITORSAVELOG_PERC)) {
 $loss_threshold = $LIVEEDITORSAVELOG_PERC;
 }

 
 $length = mb_strlen($value_tosave, "UTF-8");
 $sql = "SELECT CHAR_LENGTH(value_text) len FROM page LEFT JOIN contenttag ON page.content_id = contenttag.content_id LEFT JOIN value ON value.contenttag_id = contenttag.id WHERE ";
 $sql .= "page.id = ".sqlf_tl_num($pageid)." AND contenttag.name = '".sqlf_escaped($tagname)."' AND value.part_id = ".sqlf_tl_num($partid)." AND CHAR_LENGTH(value_text) * ( 1 - $loss_threshold / 100) >= ".sqlf_tl_num($length);
 $rs = query($sql);

 if ($rs["num"] > 0) {
 $sql = "INSERT INTO liveeditorsavelog (tagname, page_id, part_id, value_posted, value_parsed, value_ieparsed, value_pretidy, value_tidy, value_posttidy, value_tosave, user_id, timestamp, oldlength, newlength) VALUES ('".
 sqlf_escaped($tagname)."', ".sqlf_tl_num($pageid).", ".sqlf_tl_num($partid).", '".sqlf_escaped($value_posted)."', '".sqlf_escaped($value_parsed)."', '".sqlf_escaped($value_ieparsed)."', '".sqlf_escaped($value_pretidy)."', '".sqlf_escaped($value_tidy)."', '".sqlf_escaped($value_posttidy)."', '".sqlf_escaped($value_tosave)."', ".sqlf_tl_num($USER_ID).", ".sqlf_tl_num($TIME).", ".
 sqlf_tl_num($rs["arr"][0]["len"]).", ".sqlf_tl_num($length).")";
 query($sql);
 }
}

class SaveTagTranslator extends TagTranslator
{
 function translate( $tag, $content, $closer, $subject, $start, $end )
 {
 global $TAG_PREFIX;
 
 if (preg_match( "/id=\"?t_([^ >\"]*)/i", $tag, $matches )) {
 return "<$TAG_PREFIX ".$matches[1].">";
 } else {
 return $tag.$content.$closer;
 }
 }
}



GUIFactory::setMainGUI( "dialog" );

node_class("liveeditparser");


$onoff = 1;
$trans = new SaveTagTranslator();
$didSave = false;

$liveedit = new LiveEditParser();



if ( is_array($part) )
{
 while (list($k,$v) = each($part)) {
 $sql = "SELECT part.*, construct.id AS cid, contenttag.id AS tid, contenttag.name AS tname, contenttag.enabled FROM page 
	LEFT JOIN content ON content.id = page.content_id
	LEFT JOIN contenttag ON contenttag.content_id = content.id
	LEFT JOIN construct ON construct.id = contenttag.construct_id
	LEFT JOIN part ON part.construct_id = construct.id
	WHERE contenttag.name = '".sqlf_escaped($k)."' AND page.id = ".sqlf_tl_num($p_id)."
	";
 $rs = query($sql);
 
 $parts = Array();
 while (list($key,$val) = each($rs["arr"])) {
 set_time_limit($MAX_EXECTIME);

 if ($val["editable"] == 2) {
 if ( $DEBUG["tag_save"] ) { 
 echo "<br><br><br>";
 echo i18n("cn_converting").": tagname(".$val["tname"].") partorder(".$val["partorder"].")";
 }
 $part_name = "p".$val["id"]."_a";
 if ( isset( $part[$k][$val["partorder"]] ) ) {
 $content = $part[$k][$val["partorder"]];

 
 $value_posted = $content;

 if ( !$FEATURE["UTF8"] )
 $tmp = escape_decode( $content );
 else
 $tmp = $content;
 
 $parts[] = $part_name;
 if ( $DEBUG["tag_save"] ) {
 echo "<br>\n&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;";
 echo "<br>\noriginal input: ".$content;
 echo "<br>\n&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;&gt;";
 echo "<br>\n".i18n("input").": ".htmlentities_utf8($tmp, ENT_QUOTES, "UTF-8");
 }
 
 
 $tmp = parse_tags( $tmp, array( "<div", "<span" ), array( "</div", "</span" ), $trans );

 
 $value_parsed = $tmp;

 if ($FEATURE["livespellcheck"]) {
 
 $tmp = preg_replace("/<\?xml:namespace prefix = gtx \/>/i", "", $tmp);
 
 
 $tmp = preg_replace("/<\/?gtx:span[^>]*?>/i", "", $tmp);
 }
 $tmp = $liveedit->parseIECode($tmp);

 
 $value_ieparsed = $tmp;

 if ( $DEBUG["tag_save"] ) {
 echo "<br>\n---------------";
 echo "<br>\n".i18n("cn_output").": ". htmlentities_utf8($tmp, ENT_QUOTES, "UTF-8");
 echo "<br>\n&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;&lt;";
 }
 
 
 if (isLiveEditTidy() && $tmp) {
 
 $tmp = preg_replace('/<node ([^>]*?)>/s', '#NODETAG#3948102#\\1#NODETAG#', $tmp);
 $value_pretidy = $tmp;

 
 global $CN_LOCAL_SERVER, $NODE_ID;
 
 if ($FEATURE["use_php_streaming_api"]) {
 $fetcher = new FetchStream("POST");
 } else {
 $fetcher = new FetchCurl("POST");
 }

 $fetcher->setURL($CN_LOCAL_SERVER . $PORTLETAPP_PREFIX_INTERNAL . "tidy?node_id=$NODE_ID");
 $fetcher->setHeader("Connection", "close");
 $fetcher->setHeader("Content-Type", "text/html; charset=UTF-8");
 $fetcher->setPostData($tmp);
 
 $responseContent = $fetcher->sendRequest();
 if ($fetcher->getReturnCode() == "200" && $responseContent) {
 $tmp = $responseContent;
 $value_tidy = $tmp;
 }
 
 
 $tmp = preg_replace('/#NODETAG#3948102#([^#]*?)#NODETAG#/s', '<node \\1>', $tmp);

 
 $value_posttidy = $tmp;
 }

 
 $value_tosave = $tmp;

 $$part_name = $tmp;
 $$part_name = str_replace( "\n", "", $$part_name );
 $$part_name = str_replace( "\r", "", $$part_name );
 
 if ( $$part_name == "&nbsp;&nbsp;" )
 $$part_name = "";

 
 logPossibleDataLoss($k, $p_id, $val["id"], $value_posted, $value_parsed, $value_ieparsed, $value_pretidy, $value_tidy, $value_posttidy, $value_tosave);
 }
 } else {
 if ( $DEBUG["tag_save"] ) {
 echo "<br><br><br>";
 echo i18n("cn_ignoring").": tagname(".$val["tname"].") partorder(".$val["partorder"].")";
 }
 }
 }
 $__tmp__ = $TABLE_TAG;
 unset($TABLE_TAG);
 $didSave = TRUE;
 global $onoff;
 $onoff = $rs["arr"][0]["enabled"];

 
 
 
 $changePageStatus = false;

 tag_fill(implode(";",$parts), $rs["arr"][0]["cid"], true, "content", $rs["arr"][0]["tid"], $changePageStatus);
 if (is_global_validation_error()) {
 
 
 
 $JS .= global_validation_error_js_alert();
 
 
 
 
 $JS .= 'opener.cn3_document_changed = true;';
 
 $JS .= 'stop_progress(opener.top.menu);';

 
 $didSave = FALSE;
 
 
 break;
 }

 $TABLE_TAG = $__tmp__;
 }

 
 
 set_page_status_after_edit($p_id);

 objtranslatecache_clear( $p_id, $T_PAGE );

 
 if ($FEATURE["javaparser"]) {
 $javaParser =& CodeParser::getJavaParser();
 $javaParser->clearCache($T_PAGE, $p_id);
 }
}

?>
