<?

class minibrowser extends BaseObject {

 var $root_id;
 var $root_type;
 var $types;
 var $keyname;
 var $ico;
 var $link;
 var $t_type;
 var $tree_id;
 var $tree_type;
 var $finished;

 var $checkboxes;
 var $expandchk;
 var $tree_checked;
 var $tree_checkchanges;
 var $reload_check;
 
 var $allowCancel;
 var $allowOK;
 
 var $steps;
 var $steprs;
 var $step;

 var $last_form;
 var $last_tree;

 var $d_isOK;
 var $d_isCancel;

 var $header;
 var $fullHeader;

 var $displayTypes;

 var $treeNodeFormatter = null;

 function minibrowser($root_id, $root_type, $keyname = "minibrowser") {
 global $STAG, $DO;
 $this->root_id = $root_id;
 $this->root_type = $root_type;
 $this->keyname = $keyname;
 $this->ico = "";
 $this->link = "";
 $this->checkboxes = array();
 $this->expandchk = array();
 $this->tree_checked = array();
 $this->tree_checkchanges = array();
 $this->reload_check = array();
 $this->types = array();
 $this->t_type = false;
 $this->steps = array();
 $this->steprs = array();
 $this->tree_type = 0;
 $this->tree_id = 0;
 $this->finished = false;
 $this->step = false;
 $this->allowCancel = true;
 $this->allowOK = false;
 $this->last_form = false;
 $this->last_tree = false;
 $this->d_isOK = false;
 $this->d_isCancel = false;
 $this->header = "";
 $this->fullHeader = false;
 $this->displayTypes = null;
 }
 
 function getSerializeKey()
 {
 $rs = $this->assignVars(
 array(
 "root_id", "root_type","types","keyname","ico","link","t_type","tree_id",
 "tree_type","finished",
 "checkboxes","expandchk","tree_checked","tree_checkchanges","reload_check",
 "allowCancel","allowOK", 
 "step",
 "last_form","last_tree",
 "d_isOK","d_isCancel",
 "header","fullHeader", 
 "displayTypes"
 ) 
 );
 $rs["parent"] = parent::getSerializeKey();
 $rs["steps"] = array_node_serialize( $this->steps );
 $rs["steprs"] = array_node_serialize( $this->steprs );
 $rs["treeNodeFormatter"] = node_serialize( $this->treeNodeFormatter );
 return $rs;
 }
 
 function initFromSerializeKey($key)
 {
 parent::initFromSerializeKey( $key["parent"] );
 $this->restoreVars( 
 $key,
 array(
 "root_id", "root_type","types","keyname","ico","link","t_type","tree_id",
 "tree_type","finished",
 "checkboxes","expandchk","tree_checked","tree_checkchanges","reload_check",
 "allowCancel","allowOK", 
 "step",
 "last_form","last_tree",
 "d_isOK","d_isCancel",
 "header","fullHeader", 
 "displayTypes"
 ) 
 );
 $this->steps = &array_node_unserialize( $key["steps"] ); 
 $this->steprs = &array_node_unserialize( $key["steprs"] );
 $this->treeNodeFormatter = &node_unserialize( $key["treeNodeFormatter"] );
 }

 function getRootID() {
 return $this->root_id;
 }

 function getRootType() {
 return $this->root_type;
 }

 function getKeyname() {
 return $this->keyname;
 }

 function getIcon() {
 return $this->ico;
 }
 
 function getLinkParams() {
 return $this->link;
 }
 
 function getLink($full = true) {
 global $STAG, $DO;
 $link = "";
 if ($full) $link .= "$STAG&do=$DO&";
 $link .= $this->keyname."_submit=1";
 if ($this->link) $link .= "&".$this->link;
 return $link;
 }
 
 function getTType() {
 return $this->t_type;
 }
 
 function getHeader() {
 return $this->header;
 }

 function hasFullHeader() {
 return $this->fullHeader;
 }

 function hasOKBtn() {
 return $this->allowOK;
 }

 function hasCancelBtn() {
 return $this->allowCancel;
 }
 
 function setHeader($header) {
 $this->header = $header;
 }

 function useFullHeader($val) {
 $this->fullHeader = $val;
 }
 
 function setRootID($val) {
 $this->root_id = $val;
 }

 function setRootType($val) {
 $this->root_type = $val;
 }

 function setIcon($val) {
 $this->ico = $val;
 }

 function setTType($val) {
 $this->t_type = $val;
 }
 
 function setLinkParams($val) {
 $this->link = $val;
 }
 
 function allowOKBtn($val) {
 $this->allowOK = $val;
 }

 function allowCancelBtn($val) {
 $this->allowCancel = $val;
 }
 
 function addType($type_id) {
 $this->types[$type_id] = true;
 }

 function delType($type_id) {
 unset($this->types[$type_id]);
 }

 function clearTypes() {
 $this->types = array();
 }

 function addCheckType($type_id, $allowCheck = true) {
 $this->checkboxes[$type_id] = $allowCheck;
 $this->tree_checked[$type_id] = array();
 $this->tree_checkchanges[$type_id] = array();
 }

 function delCheckType($type_id) {
 unset($this->checkboxes[$type_id]);
 unset($this->tree_checked[$type_id]);
 unset($this->tree_checkchanges[$type_id]);
 }

 function clearCheckTypes() {
 $this->checkboxes = array();
 }

 function addStepDS(&$ds) {
 
 $step = count($this->steps) + 1;
 $this->steps[$step] =& $ds;
 return $step;
 }

 function setStepDS($step, &$ds) {
 $this->steps[$step] = &$ds;
 }

 function delStep($step) {
 unset($this->steps[$step]);
 }

 function clearSteps() {
 $this->steps = array();
 }

 function rehashSteps() {
 
 }

 function getStepCount() {
 return count($this->steps);
 }

 function getFolderID() {
 return $this->tree_id;
 }

 function getFolderType() {
 return $this->tree_type;
 }

 function getCheckedIDs($type) {
 $rs = array();
 reset($this->tree_checked[$type]);
 while (list($key,$val) = each($this->tree_checked[$type])) {
 if (!isset($this->tree_checkchanges[$key]) || $this->tree_checkchanges) {
 $rs[$key] = true;
 }
 }
 reset($this->tree_checkchanges[$type]);
 while (list($key,$val) = each($this->tree_checkchanges[$type])) {
 if ($val) $rs[$key] = true;
 }
 return $rs;
 }

 function getCheckChangedIDs($type) {
 return $this->tree_checkchanges[$type];
 }

 function getResultID($step = false) {
 if (is_false($step)) {
 return $this->steprs[$this->step];
 } else {
 return $this->steprs[$step];
 }
 }

 function setFolder($id, $type) {
 $this->tree_id = $id;
 $this->tree_type = $type;
 }

 function setResultID($step, $value) {
 $this->steprs[$step] = $value;
 }

 function setCheckedIDs($type, $ids) {
 $this->tree_checkchanges[$type] = array();
 $this->tree_checked[$type] = $ids;
 $this->reload_check[$type] = true;
 }

 function expandChecked($type = false) {
 if (is_false($type)) {
 reset($this->checkboxes);
 while (list($key,$val) = each($this->checkboxes)) {
 if (!is_false($key)) $this->expandChecked($key);
 }
 } else {
 $this->expandchk[$type] = true;
 }
 }

 function isSubmit() {
 global ${$this->keyname."_submit"};
 return (${$this->keyname."_submit"})?true:false;
 }

 function setStep($step) {
 $this->step = $step;
 }

 function getStep() {
 return $this->step;
 }

 function getSteps() {
 return array_keys($this->steps);
 }

 function isLastStep() {
 return (is_false($this->getNextStep($this->step)))?true:false;
 }

 function getNextStep($step) {
 $keys = array_keys($this->steps);
 for ($i = 0; $i < count($keys) - 1; $i++) {
 if ($keys[$i] == $step) return $keys[$i + 1];
 }
 return false;
 }

 function getLastStep($step) {
 $keys = array_keys($this->steps);
 for ($i = count($keys) - 1; $i > 0; $i--) {
 if ($keys[$i] == $step) return $keys[$i - 1];
 }
 return false;
 }
 
 function getMaxStepID() {
 $keys = array_keys($this->steps);
 return $keys[count($keys) - 1];
 }
 
 function isFinished() {
 return $this->finished;
 }

 function isCancelled() {
 return $this->d_isCancel;
 }

 function isOK() {
 return $this->d_isOK;
 }

 function initFromSubmit() {
 if (!$this->isSubmit()) return;
 
 global ${$this->keyname."_step"};
 if (${$this->keyname."_step"}) $this->step = ${$this->keyname."_step"};

 global ${$this->keyname."_linkvar"};
 if (${$this->keyname."_linkvar"}) $this->tree_id = ${$this->keyname."_linkvar"};

 global ${$this->keyname."_linktype"};
 if (${$this->keyname."_linktype"}) $this->tree_type = ${$this->keyname."_linktype"};
 
 global ${$this->keyname."_listid"};
 if (${$this->keyname."_listid"}) {
 $this->steprs[$this->step] = ${$this->keyname."_listid"};
 if ($this->treeNodeFormatter) {
 $this->treeNodeFormatter->selector->toggle(${$this->keyname."_listid"});
 }
 }

 global ${$this->keyname."_next"};
 if (${$this->keyname."_next"}) {
 if ($this->isLastStep()) {
 $this->finished = true;
 } else {
 $this->step = $this->getNextStep($this->step);
 }
 }
 
 
 if ($this->last_form) {
 $f = $this->_genForm();
 global $faction;
 
 if ($faction == "ok" && $this->allowOK && $f->issubmit) {
 $this->d_isOK = true;
 $this->finished = true;
 }
 if ($faction == "cancel" && $this->allowCancel && $f->issubmit) {
 $this->d_isCancel = true;
 $this->finished = true;
 }
 }
 
 
 if (count($this->checkboxes) > 0 && $this->last_tree) {
 
 $t = $this->_genTree($this->last_tree);
 $t->check_changes();
 
 
 reset($this->checkboxes);
 while (list($type,$val) = each($this->checkboxes)) {
 $chk = $t->type[$type]["chkvar"];
 global $$chk;
 $this->tree_checkchanges[$type] = $$chk;
 }
 }
 
 global ${$this->keyname."_fa"};
 global ${$this->keyname."_faval"};
 global ${$this->keyname."_idx"};
 if (${$this->keyname."_fa"} && $this->treeNodeFormatter) {
 
 $this->treeNodeFormatter->callAction(${$this->keyname."_fa"}, ${$this->keyname."_faval"}, ${$this->keyname."_idx"});
 }
 }

 function resetFinished() {
 $this->finished = false;
 $this->d_isCancel = false;
 $this->d_isOK = false;
 }
 
 function getHTML() {
 
 return $this->_buildForm();
 }

 function addDisplayType($type) {
 if (! $this->displayTypes) {
 $this->displayTypes = array();
 }
 $this->displayTypes[] = $type;
 }

 function setDisplayTypes($types) {
 $this->displayTypes = $types;
 }

 function _genForm() {
 global $HI;
 
 $hi = array();
 
 $hi[] = $HI["ok"];
 $hi[] = $HI["cancel"];
 
 $f = new htmlform($hi,$this->keyname."_form");
 $this->last_form = true;

 $f->faction = $this->getLink()."&".$this->keyname."_submit=1";

 return $f;
 }

 function _buildForm() {
 $f = $this->_genForm();
 
 $html = $this->_buildFormHtml($f->formname);
 $b = array();
 if ($this->allowOK) $b[] = $f->e("ok");
 if ($this->allowCancel) $b[] = $f->e("cancel");

 $out = $f->start();
 $out .= dialog($html, $b, "normal", $this->header, $this->ico);
 $out .= $f->end();

 return $out;
 }

 function _buildFormHtml($formName) {
 $out = "<table>\n";
 $out .= "<tr><td colspan=3>".$this->_buildFormHeader()."</td></tr>\n";
 $out .= "<tr valign=top><td>".$this->_buildTree($formName)."</td><td>&nbsp;&nbsp;</td><td>".$this->_buildList($formName)."</td></tr>\n";
 $out .= "</table>\n";
 return $out;
 }

 function _genTree($formName) {
 global $T_TYPE, $DO;
 if (is_array($this->t_type)) {
 $type = $this->t_type;
 } else {
 $type = $T_TYPE;
 }
 
 $t = new tree($type);
 $t->setTreeNodeFormatter($this->treeNodeFormatter);
 $t->openvar = $this->keyname."_tree";
 $t->showasform = true;
 $t->treelink = $this->getLink();
 $t->setDisplayTypes($this->displayTypes);

 reset($t->type);
 while(list($type,$val) = each($t->type)) {
 $t->type[$type]["allowlink"] = false;
 $t->type[$type]["allowchk"] = false;
 }

 reset($this->steps);
 if (list($step,$ds) = each($this->steps)) {
 $link = "do=$DO&".$this->getLink(false)."&".$this->keyname."_step=$step";
 } else {
 $link = "do=$DO&".$this->getLink(false)."&".$this->keyname."_next=1";
 }

 reset($this->types);
 while (list($type,$val) = each($this->types)) {
 if (!$val) continue;

 $t->type[$type]["allowlink"] = true;
 $t->type[$type]["linktarget"] = "_self";
 $t->type[$type]["linkvar"] = $this->keyname."_linkvar";
 $t->type[$type]["link"] = $link."&".$this->keyname."_linktype=$type";
 }
 
 reset($this->checkboxes);
 while (list($type,$allow) = each($this->checkboxes)) {
 $t->type[$type]["allowchk"] = $allow;
 $t->type[$type]["chkvar"] = $this->keyname."_chk$type";
 $t->type[$type]["chkval"] = $this->tree_checked[$type];
 }

 reset($this->reload_check);
 while (list($type, $val) = each($this->reload_check)) {
 
 if (!$val) continue;
 $chk = $t->type[$type]["chkvar"];
 global $$chk;
 $$chk = array();
 $this->reload_check[$type] = false;
 }

 reset($this->expandchk);
 while (list($type, $val) = each($this->expandchk)) {
 
 if (!$val) continue;
 $t->openchecked();
 $this->expandchk[$type] = false;
 }
 
 return $t;
 }

 function _buildTree($formName) {
 
 $t = $this->_genTree($formName);
 
 $out = $t->walktree($this->root_id, false, 0, $this->root_type);

 $this->last_tree = $formName;
 
 return $out;
 }

 function _buildList($formName) {
 
 if (is_false($this->step)) return "";

 $ds =& $this->steps[$this->step];

 $ds->setFolderID($this->tree_id);
 $ds->setFolderType($this->tree_type);
 $ds->setID($this->steprs[$this->step]);
 $ds->setBaseLink($this->getLink()."&".$this->keyname."_next=1&".$this->keyname."_listid=");

 $lst = new ItemList3($this->keyname."_list",$ds);
 if (method_exists($ds, "initItemList")) {
 $ds->initItemList($lst);
 }
 $lst->setParentForm($formName);
 $lst->setLinkAppendix($this->getLink(false));
 $out = $lst->getHTMLOutput();

 return $out;
 }
 
 function _buildFormHeader() {
 if ($this->fullHeader) {
 
 
 }
 return $header;
 }

 function setTreeNodeFormatter(&$treeNodeFormatter) {
 $this->treeNodeFormatter =& $treeNodeFormatter;
 }
 
}






class MiniDatasource extends ItemListActionDataSource {
 
 var $folder_id;
 var $folder_type;
 var $list_id;
 var $baselink;
 
 function MiniDatasource() {
 $this->folder_id = 0;
 $this->folder_type = 0;
 $this->list_id = 0;
 $this->baselink = "";
 }
 
 function setFolderID($id) {
 $this->folder_id = $id;
 }

 function setFolderType($type) {
 $this->folder_type = $type;
 }

 function setID($id) {
 $this->list_id = $id;
 }
 
 function setBaseLink($link) {
 $this->baselink = $link;
 }
 
 function getFolderID() {
 return $this->folder_id;
 }

 function getFolderType() {
 return $this->folder_type;
 }
 
 function getID() {
 return $this->list_id;
 }
 
 function buildLink($id) {
 return $this->baselink.$id;
 }
 
}






class MiniItemlistDatasource extends MiniDatasource {

 var $ds;

 function MiniItemlistDatasource($ds) {
 $this->MiniDatasource();
 $this->ds = $ds;
 }

}







class MiniGenericDatasource extends MiniDatasource {

 var $hasHeader;
 
 var $cols;
 var $colheader;
 var $colshow;
 var $colsort;

 var $sortedcol;
 var $sortedway;
 
 function MiniGenericDatasource() {
 global $DB;
 $this->MiniDatasource();
 $this->hasHeader = false;
 $this->cols = array();
 $this->colheader = array();
 $this->colshow = array();
 $this->colsort = array();
 $this->sortedcol = "";
 $this->sortedway = "ASC";
 }
 
 function showColumnHeader($val) {
 $this->hasHeader = $val;
 }

 function setColumn($colname, $header = "", $visible = false, $sortable = false) {
 $this->colheader[$colname] = $header;
 $this->colshow[$colname] = $visible;
 $this->colsort[$colname] = $sortable;
 }

 function showColumn($colname) {
 if (isset($this->colshow[$colname])) {
 $this->colshow[$colname] = true;
 };
 }

 function hideColumn($colname) {
 if (isset($this->colshow[$colname])) {
 $this->colshow[$colname] = false;
 };
 }

 function isColumnVisible($colname) {
 return isset($this->colshow[$colname]) && $this->colshow[$colname] == true;
 }

 function unsetColumn($colname) {
 unset($this->cols[$colname]);
 unset($this->colheader[$colname]);
 unset($this->colshow[$colname]);
 unset($this->colsort[$colname]);
 if ($colname == $this->sortedcol) {
 $this->sortedcol = "";
 $this->sortedway = "";
 }
 }

 function clearColumns() {
 $this->cols = array();
 $this->colheader = array();
 $this->colshow = array();
 $this->colsort = array();
 $this->sortedcol = "";
 $this->sortedway = "";
 }
 
 function setSortColumn($column, $way = "ASC") {
 if ($this->colsort[$column]) {
 $this->sortedcol = $column;
 $this->sortedway = $way;
 }
 }
 
 function isSearchable() {
 return false;
 }

 function setSort( $column, $way ) {
 if ($this->colsort[$column]) {
 $this->sortedcol = $column;
 $this->sortedway = $way;
 }
 }

 function getCurrentSort( &$column, &$way ) {
 if ($this->sortedcol) {
 $column = $this->sortedcol;
 $way = (strtolower($this->sortedway == "desc"))?"DESC":"ASC";
 return true;
 } else {
 return false;
 }
 }

 function getSortWays( $column ) {
 global $ICO_SORT_ASC, $ICO_SORT_DESC;

 if ($this->colsort[$column]) {
 return array( array( "way" => "ASC", "icon" => $ICO_SORT_ASC), array ( "way" => "DESC", "icon" => $ICO_SORT_DESC) );
 } else {
 return array();
 }
 }

 function getColumns() {
 $rs = array();
 
 reset($this->colheader);
 while (list($key,$val) = each($this->colheader)) {
 if ($this->colshow[$key]) $rs[] = $key;
 }
 return $rs;
 }

 function hasColumnHeaders() {
 return $this->hasHeader;
 }
 
 function getColumnHeader( $column ) {
 return $this->colheader[$column];
 }

 function getColumnAttribs( $column ) {
 return " nowrap";
 }

 function getRowHelp( $rowKey, $rowData ) {
 return "";
 }

}
?>
